#!/bin/sh

if [ "x$1" = "xclean" ]; then
	echo Cleaning
	echo DONDOODODNODNODNODNODNO
	make distclean
  rm -f confi
  rm -rf autom4te.cache config.aux m4
	exit
fi

## Generate Makefile.am from MD5SUMS
PSOURCE=humanoidbat.cc
PNAME=`basename "${PSOURCE}" .cc`
echo "Generating Makefile.am from MD5SUMS"
#Update MD5SUMS
which ccbuild && (ccbuild md5 --recursive-include . "${PSOURCE}" > MD5SUMS)

SOURCES=`sed  -r 's/^[a-z0-9]+  //; s/ /\\ /' < MD5SUMS | tr '\n' ' '`

#Overwrite Makefile.am
cat > Makefile.am <<EOF
#THIS FILE IS AUTOMATICALLY GENERATED AUTOMATICALLY
PACKAGE = @PACKAGE@
VERSION = @VERSION@

AUTOMAKE_OPTIONS = subdir-objects

bin_PROGRAMS = ${PNAME}

#List of source files needed to build the executable:
${PNAME}_SOURCES = ${SOURCES}

INCLUDES = \$(DEPS_CFLAGS) -I. -I./AST -I./BatsException -I./Behavior -I./Behavior/BeamTo -I./Behavior/Challenge1 -I./Behavior/Console -I./Behavior/Empty -I./Behavior/GetFromSide -I./Behavior/GetUpFromBack -I./Behavior/GetUpFromBelly -I./Behavior/GoodPosition -I./Behavior/GoodPositionAngle -I./Behavior/GuardGoal -I./Behavior/KeeperGetUp -I./Behavior/KickTo -I./Behavior/MiniWalkBackward -I./Behavior/MiniWalkForward -I./Behavior/MoveJointTo -I./Behavior/PrimitiveBehavior -I./Behavior/PrimitiveBehavior/Beam -I./Behavior/PrimitiveBehavior/MoveHingeJoint -I./Behavior/PrimitiveBehavior/MoveJoint -I./Behavior/PrimitiveBehavior/MoveUniversalJoint -I./Behavior/Score -I./Behavior/ScriptPlayer -I./Behavior/Sine -I./Behavior/StrafeLeft -I./Behavior/StrafeRight -I./Behavior/StrafeToBall -I./Behavior/TurnTo -I./Behavior/Wait -I./Behavior/WalkStraightTo -I./Behavior/WalkTo -I./Behavior/canKickLeft -I./Behavior/canKickRight -I./Behavior/canTurnLeft -I./Behavior/canTurnRight -I./Cerebellum -I./Conf -I./Distribution1 -I./Distribution1/NormalDistribution1 -I./Distribution3D -I./Distribution3D/MonteCarloDistribution -I./Distribution3D/NormalDistribution3D -I./FitnessFunction -I./FitnessFunction/FitnessTurn -I./FitnessFunction/FitnessWalk -I./Hashclasses -I./HumanoidAgent -I./HumanoidAgent/HumanoidBat -I./Input -I./Logger -I./Math -I./Matrix4D -I./Matrix9 -I./Net -I./Parser -I./Path -I./PortableParser -I./Predicate -I./Preprocessor -I./Ref -I./RefAble -I./SocketComm -I./Talent -I./Types -I./Vector3 -I./Vector4 -I./WorldModel -I./autom4te.cache -I./confinc -I./docs -I./docs/TDP -I./docs/agent_paper -I./docs/howtorobocop -I./docs/img -I./global -I./util

${PNAME}_LDADD = \$(DEPS_LIBS)
EOF

rm -f config.cache acconfig.h

echo "- aclocal-1.9."		&& \
aclocal-1.10	&& \
echo "- autoconf."		&& \
autoconf			&& \
echo "- automake-1.9."		&& \
automake-1.10 --add-missing --copy

